Incorrect sorting of users grouped by status in issue filters for administrators

2024-07-30 20:38 - Vladislav Moiseev

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Filters Estimated time: 0.00 hour

Target version: 5.1.4   

Resolution: Fixed Affected version: 5.1.3

Description

In #15201 default sorting for filter options linked with principals (users) was changed.

And now principal options into issue query filters for system admins was broken.

Attached patch for current trunk is fixed this problem.

Redmine instance infoRedmine instance info

Environment:

  Redmine version                5.1.3.stable

  Ruby version                   3.2.5-p208 (2024-07-26) [x86_64-linux-musl]

  Rails version                  6.1.7.8

  Environment                    production

  Database adapter               PostgreSQL

  Mailer queue                   ActiveJob::QueueAdapters::AsyncAdapter

  Mailer delivery                smtp

Redmine settings:

  Redmine theme                  Default

SCM:

  Subversion                     1.14.3

  Mercurial                      6.7.4

  Bazaar                         3.3.4

  Git                            2.45.2

  Filesystem                     

  GitRemote                      2.45.2

Redmine plugins:

  redmine_git_remote             0.0.3

  redmine_issue_templates        1.1.2

Related issues:

Related to Redmine - Feature #15201: Filter "Assignee" should contain locked ... Closed

Has duplicate Redmine - Defect #33616: Assignee & Author Dropdown Sort Closed

Associated revisions

Revision 22947 - 2024-08-11 10:30 - Go MAEDA

Fix incorrect sorting of users grouped by status in issue filters for administrators (#41079).

Patch by Vladislav Moiseev (user:vladdy.moses).

Revision 22948 - 2024-08-11 10:33 - Go MAEDA

Add test for r22947 (#41079).

Revision 22957 - 2024-08-13 03:34 - Go MAEDA

Merged r22947 and r22948 from trunk to 5.1-stable (#41079).

History

#1 - 2024-07-31 07:47 - Go MAEDA
https://www.redmine.org/issues/15201


- File clipboard-202407311446-b3ipf.png added

I was unable to reproduce the issue you mentioned in my environment. The users in the dropdown are correctly sorted.

Could you please let me know how I can reproduce the problem?

 clipboard-202407311446-b3ipf.png 

#2 - 2024-07-31 14:37 - Vladislav Moiseev

- File 2024-07-31_16-29-40.png added

- File users.csv added

- File 2024-07-31_16-33-00.png added

To reproduce this behaviour I installed new redmine instance with default configuration (English).

Then I imported users from users.csv (attached) using default wizard config like this:

 2024-07-31_16-29-40.png 

Then I created new project, linked all active users and one locked ("ddd" in my case) as managers.

And.. filter sorting was broken:

 2024-07-31_16-33-00.png 

#3 - 2024-08-01 09:22 - Go MAEDA

- Category set to Filters

- Status changed from New to Confirmed

Thank you for letting me know the steps to reproduce the issue.

I have confirmed the issue.

#4 - 2024-08-04 14:46 - Go MAEDA

- File test-41079.patch added

- Target version set to Candidate for next minor release

I wrote a test to catch the wrong behavior.

$ bin/rails test test/unit/query_test.rb:3348

Run options: --seed 31819

# Running:

F

Failure:

QueryTest#test_assigned_to_values_should_be_sorted_by_status_and_name [test/unit/query_test.rb:3360]:

--- expected

+++ actual

@@ -1 +1 @@

-["000 000", "002 002", "004 004", "006 006", "008 008", "010 010", "012 012", "014 014", "016 016", "018 018"

, "001 001", "003 003", "005 005", "007 007", "009 009", "011 011", "013 013", "015 015", "017 017", "019 019"

]

+["018 018", "016 016", "014 014", "012 012", "010 010", "008 008", "006 006", "004 004", "002 002", "000 000"

, "007 007", "009 009", "005 005", "011 011", "013 013", "003 003", "015 015", "017 017", "001 001", "019 019"

]

bin/rails test test/unit/query_test.rb:3348

#5 - 2024-08-05 09:20 - Go MAEDA

- Target version changed from Candidate for next minor release to 5.0.10

Setting the target version to 5.0.10.

#6 - 2024-08-11 10:17 - Go MAEDA

- Related to Feature #15201: Filter "Assignee" should contain locked users added
#7 - 2024-08-11 10:33 - Go MAEDA

- Status changed from Confirmed to Resolved

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch in r22947. Thank you.

#8 - 2024-08-13 03:57 - Go MAEDA

- Subject changed from Wrong principal sorting into issue filters for sys-admins to Incorrect sorting of users grouped by status in issue filters for

administrators

- Status changed from Resolved to Closed

- Target version changed from 5.0.10 to 5.1.4

Merged the change to the 5.1-stable branch.

#9 - 2024-09-15 09:16 - Go MAEDA

- Has duplicate Defect #33616: Assignee & Author Dropdown Sort added

Files

query.rb.patch 1.39 KB 2024-07-30 Vladislav Moiseev

clipboard-202407311446-b3ipf.png 163 KB 2024-07-31 Go MAEDA

2024-07-31_16-29-40.png 132 KB 2024-07-31 Vladislav Moiseev

users.csv 973 Bytes 2024-07-31 Vladislav Moiseev

2024-07-31_16-33-00.png 76.5 KB 2024-07-31 Vladislav Moiseev

test-41079.patch 894 Bytes 2024-08-04 Go MAEDA

Powered by TCPDF (www.tcpdf.org)

2025-04-02 3/3

https://www.redmine.org/projects/redmine/repository/svn/revisions/22947
http://www.tcpdf.org

